Option Explicit

Sub FOpenProc ()
    On Error Resume Next
    frmMDI.CMDialog1.Filename = ""
    frmMDI.CMDialog1.Action = 1
    If Err <> 32755 Then 'user pressed cancel - NOT!
	Dim OpenFileName As String
	OpenFileName = frmMDI.CMDialog1.Filename
	If OpenFile(OpenFileName) = True Then
	    UpdateFileMenu (OpenFileName)
	End If
    End If
End Sub

Function GetFileName ()
    'Displays a Save As dialog and returns a file name
    'or an empty string if the user cancels
    On Error Resume Next
    frmMDI.CMDialog1.Filename = ""
    frmMDI.CMDialog1.Action = 2
    If Err <> 32755 Then      'User cancelled dialog
	GetFileName = frmMDI.CMDialog1.Filename
    Else
	GetFileName = ""
    End If
End Function

Function OnRecentFilesList (Filename) As Integer
  Dim i

  For i = 1 To 4
    If frmMDI.mnuRecentFile(i).Caption = Filename Then
      OnRecentFilesList = True
      Exit Function
    End If
  Next i
    OnRecentFilesList = False
End Function

Function OpenFile (Filename As String) As Integer
On Error Resume Next
    Dim fIndex As Integer

    ' change mousepointer to an hourglass
    screen.MousePointer = 11
    
    ' change form's caption and display new text
    fIndex = FindFreeIndex()

    document(fIndex).Text1.FileOpen = Filename

    ' reset mouse pointer
    screen.MousePointer = 0

    If Err Then
	OpenFile = False
	DisplayError
	Unload document(fIndex)
    Else
	OpenFile = True
	document(fIndex).Tag = fIndex
	document(fIndex).Caption = UCase$(Filename)
	document(fIndex).Show
	UpdateToolBar
    End If

End Function

Sub SaveFileAs (Filename)
On Error Resume Next
    Dim Contents As String

    ' display hourglass
    screen.MousePointer = 11

    ' write the text to the new file
    frmMDI.ActiveForm.Text1.FileSave = Filename

    ' reset the mousepointer
    screen.MousePointer = 0

    If Err Then
	DisplayError
    Else
       ' set the Notepad's caption
	frmMDI.ActiveForm.Caption = UCase$(Filename)

	' reset the dirty flag
	frmMDI.ActiveForm.Text1.IsDirty = False
    End If
End Sub

Sub UpdateFileMenu (Filename)
	Dim RetVal
	' Check if OpenFileName is already on MRU list.
	RetVal = OnRecentFilesList(Filename)
	If Not RetVal Then
	  ' Write OpenFileName to EMEDIT.INI
	  WriteRecentFiles (Filename)
	End If
	' Update menus for most recent file list.
	GetRecentFiles
End Sub

